/* 
 */
var requestAnimFrame = window.requestAnimationFrame || window.webkitRequestAnimationFrame ||
                       window.mozRequestAnimationFrame || window.msRequestAnimationFrame || 
                       function(c) {window.setTimeout(c, 15)};
                       
var globalUserShips = [];
var bitmaps = [];
	function makeObgectScene(X, Y, type, itemIn3D){
		var c, obgectScene,
			shipColor = [0,64,255],
			plumpColor = [6,121,159],
			shipFireColor = [255,0,0];

			xx = 6 - X; yy = 6 - Y;
		switch (type)
		{ 		
			case 201:
			case 202:
			case 203:
			case 204:
			case 205:
			case 206:
				itemIn3D.style.color = shipFireColor;
				//itemIn3D.translateY(1);
				itemIn3D.style._id = X+'_'+Y+'_'+type;
				var fire = Phoria.EmitterEntity.create({
				      position: {x:0, y:0, z:0},
				      positionRnd: {x:0.25, y:0.1, z:0.25},
				      rate: 75,
				      velocity: {x:0.15, y:0.15, z:0},
				      velocityRnd: {x:0.05, y:0.05, z:0.05},
				      lifetime: 250, 
				      lifetimeRnd: 250,
				      style: {
				         compositeOperation: "lighter",
				         shademode: "sprite",
				         linewidth: 2,
				         objectsortmode: "front",
				         sprite: 0
				      }
				   });
					fire.textures.push(bitmaps[0]);
					itemIn3D.children.push(fire);
					return itemIn3D;
				   
			break;
			case 102:
				obgectScene = Phoria.Entity.create({
				      points: [{x:0, y:0, z:0}],
				      style: {
				         color: plumpColor,
				         drawmode: "point",
				         shademode: "plain",
				         linewidth: 5,
				         linescale: 1
				      }
				   });
				obgectScene.translateX(xx); obgectScene.translateZ(yy);
				break;
			default:
				c = Phoria.Util.generateUnitCube(0.7);
				obgectScene = Phoria.Entity.create({
					points: c.points,
					polygons: c.polygons,
					style: {
					 _id: X+'_'+Y,
			         color: shipColor
					}
				});
				obgectScene.translateX(xx); obgectScene.translateZ(yy);
			break;
		}

		return obgectScene;
   
	}
	function init3d()
	{
		bitmaps.push(Phoria.Util.generateRadialGradientBitmap(32, "rgba(128,64,32,1)", "rgba(128,64,32,0)"));
		   var canvas = document.getElementById('canvas');
		   var scene = new Phoria.Scene();
		   scene.camera.position = {x:20.0, y:30.0, z:-30.0};
		   scene.perspective.aspect = canvas.width / canvas.height;
		   scene.viewport.width = canvas.width;
		   scene.viewport.height = canvas.height;
		   var renderer = new Phoria.CanvasRenderer(canvas);

		   var plane = Phoria.Util.generateTesselatedPlane(15, 15, 0, 20);
		   scene.graph.push(Phoria.Entity.create({
		      points: plane.points,
		      edges: plane.edges,
		      polygons: plane.polygons,
		      style: {
				 color: [68, 171, 218],
		         shademode: "plain",
		         drawmode: "wireframe",
		         linewidth: 0.2,
		         objectsortmode: "back"
		      }
		   }));
			   
			
		   scene.graph.push(Phoria.DistantLight.create({
		      direction: {x:0, y:-0.5, z:1}
		   }));

			// rotate the camera around the scene
			/*/
		   scene.onCamera(function(position, lookAt, up) {
		      var rotMatrix = mat4.create();
		      mat4.rotateY(rotMatrix, rotMatrix, Math.sin(Date.now()/10000)*Phoria.RADIANS*360);
		      vec4.transformMat4(position, position, rotMatrix);
		   });
		   //*/
	
		   var pause = false;
		   var fnAnimate = function() {
		      if (!pause)
		      {
			     if(globalUserShips['update']){
			    	var obgectScene,
						y,x;
					for (y=0; y< 16; ++y) {
						for (x=0; x<16; ++x) {
							if ( globalUserShips['items'][y][x][0] > 100
								&& !!globalUserShips['items'][y][x][3]
								&& !globalUserShips['items'][y][x][4]
							){
								globalUserShips['items'][y][x][4] = true;
								scene.graph[globalUserShips['items'][y][x][3]] = makeObgectScene(y,x, globalUserShips['items'][y][x][2], scene.graph[globalUserShips['items'][y][x][3]]);
								//console.log('do fire for '+ y + ' '+ x);
							} else if ( globalUserShips['items'][y][x][0] < 100 
								&& !globalUserShips['items'][y][x][3]
							){
								obgectScene = makeObgectScene(y,x, globalUserShips['items'][y][x][0]);
								var ind = scene.graph.push(obgectScene);
								globalUserShips['items'][y][x][3] = ind-1;
								//console.log('do ITEM for '+ y + ' '+ x);
								
							} else if(globalUserShips['items'][y][x][0] == 102
								&& !globalUserShips['items'][y][x][3]
							){
								obgectScene = makeObgectScene(y,x, globalUserShips['items'][y][x][0]);
								var ind = scene.graph.push(obgectScene);
								globalUserShips['items'][y][x][3] = ind-1;
								globalUserShips['items'][y][x][4] = true;
								//console.log('do PLAMB for '+ y + ' '+ x);
							}
						}
					}
					
					globalUserShips['update'] = false;	
				 }
		         scene.modelView();
		         renderer.render(scene);
		      }
		      requestAnimFrame(fnAnimate);
		   };   
		  
		   
		   //*/
		    // key binding
		   document.addEventListener('keydown', function(e) {
		      switch (e.keyCode)
		      {
		         case 27:
		         {
		            pause = !pause;
		            break;
		         }
		      }
		   }, false);
		   //*/
		   requestAnimFrame(fnAnimate);
	}

                       
/* CORE */
angular.module('ngProject', [                                
]).service('MessageStore', ['$rootScope', '$log', function ($rootScope, $log) {
	/*
	 * Wait while come message from root
	 * format:
		item = {
			'title': 'dd',
			'text': 'ww',
			'type': ''
		};
	*/
	var store = [];
    this.hold = function hold(item) {
    	store.unshift(item);
    	$rootScope.$broadcast('onMessageStoreHold', item);
    };

    this.getAll = function () {
        return store;
    };
    
    this.remove = function (item, cnt) {
    	var index = store.indexOf(item);
    	cnt = cnt || 1;
    	if(index >= 0){
    		store.splice(index, cnt);
    	}
        return index;
    };

    this.clean = function clean() {
    	store = [];
    };
}])
.controller('MessageController',[
	'MessageStore',
	'$scope',
	'$rootScope',
	'$interval',
	'$log',
	function (msgstore, $scope, $rootScope, $interval, $log) {
		$scope.messages = [];
		$scope.messagesMax = 4;
		$scope.messagesRemInterval = 2000;
		$scope.promise = undefined;
                 		
		$rootScope.$on('onMessageStoreHold', function(event) {
				$scope.messages = msgstore.getAll();
				var ttl = $scope.messages.length;
				if(ttl > $scope.messagesMax){
					msgstore.remove($scope.messages[($scope.messagesMax)], ttl - $scope.messagesMax);
				}
				
				$scope.autoRemove();	
			;
		});
   		$scope.remove = function(messege){
   			msgstore.remove(messege);
   		};      		
   		$scope.autoRemove = function(){
   			if(angular.isDefined($scope.promise)) return;
   			$scope.promise = $interval(function() {
   				if($scope.messages.length > 0){
   					var numMsg = $scope.messages.length - 1;
   					msgstore.remove($scope.messages[numMsg]);
   				}else{
   					$scope.stopPromise();
   				}
   		    }, $scope.messagesRemInterval);
   		};

   		$scope.stopPromise = function(){
   			if (angular.isDefined($scope.promise)) {
   				$interval.cancel($scope.promise);
   				$scope.promise = undefined;
   			}
   		}
}])
.controller('IndexCtrl', ['$scope', 'MessageStore', '$interval', '$log', function($scope, msgstore, $interval, $log) {
	
	var ship =  [[[1,5], [1,2,5], [1,2,3,5], [1,2,3,4,5]], 
				[[6,10], [6,7,10], [6,7,8,10], [6,7,8,9,10]]],
		dead = 	[[[201,203], [201,202,203], [201,202,202,203], [201,202,202,202,203]], 
				[[204,206], [204,205,206], [204,205,205,206], [204,205,205,205,206]]],
	    gridy = gridx = 16;
		
	$scope.player = [];
	$scope.computer = [];
	$scope.playersships = [];
	$scope.computersships = [];
	$scope.playerlives = 0;
	$scope.computerlives = 0;
	$scope.params = {
		playflag: true, // остановка игры
		gridx: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 ,13, 14, 15], 
		gridy: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12 ,13, 14, 15],
		shiptypes: [
						["Эсминец", 2, 4],
						["Крейсер", 3, 4],
						["Подводная лодка", 4, 2],
						["Авианосец", 5, 1]
					],
		status: []
	};

	/******** functions ****/
	$scope.autoPlay = function(){
		var timeoutId = $interval(function(){
			if ( $scope.params.playflag  ) {
			  computerMove();
			}else{
			  $interval.cancel(timeoutId);
			}
		}, 1000);
	};			
	$scope.gridClick = function(y,x) {
		if ( $scope.params.playflag  ) {
			if ($scope.computer[y][x][0] < 100) {
				/* Player misses ------------------------------------------*/
				setImage( y,x, 103, true);
				var shipno = $scope.computer[y][x][1];
				if ( --$scope.computersships[shipno][1] == 0 ) {
					sinkShip($scope.computer, shipno, true);
					msgstore.hold({
						'title': ' >> Boom << ',
						'text': "Ты потопил " + $scope.params.shiptypes[$scope.computersships[shipno][0]][0]+"!",
						'type': 'alert-info'
					});
					//$log.debug("You sank my " + $scope.params.shiptypes[$scope.computersships[shipno][0]][0]+"!");
					$scope.updateStatus();
					if ( --$scope.computerlives == 0 ) {
						msgstore.hold({
							'title': 'Ты победил!',
							'text': "Обновляй страницу и продолжим играть",
							'type': 'alert-success'
						});
						$scope.params.playflag = false;
					}
				}
				if ( $scope.params.playflag ){
					
				}
			}else if ($scope.computer[y][x][0] == 100) {
				setImage(y,x,102,true);
				computerMove();
			}
		}
	}

	function computerMove() {
		var x,y,pass;
		var sx,sy;
		var selected = false;
		for (pass=0;pass<2;++pass) {
			for (y=0;y < gridy && !selected;++y) {
				for (x=0;x<gridx && !selected;++x) {
					if ($scope.player[y][x][0]==103) {
						sx=x;
						sy=y;
						var nup=(y>0 && $scope.player[y-1][x][0]<=100);
						var ndn=(y<gridy-1 && $scope.player[y+1][x][0]<=100);
						var nlt=(x>0 && $scope.player[y][x-1][0]<=100);
						var nrt=(x<gridx-1 && $scope.player[y][x+1][0]<=100);
						if ( pass == 0 ) {
							var yup=(y>0 && $scope.player[y-1][x][0]==103);
							var ydn=(y<gridy-1 && $scope.player[y+1][x][0]==103);
							var ylt=(x>0 && $scope.player[y][x-1][0]==103);
							var yrt=(x<gridx-1 && $scope.player[y][x+1][0]==103);
							if ( nlt && yrt) {
								sx = x-1;
								selected=true;
							}else if ( nrt && ylt) {
								sx = x+1;
								selected=true;
							}else if ( nup && ydn) {
								sy = y-1;
								selected=true;
							}else if ( ndn && yup) {
								sy = y+1;
								selected=true;
							}
						}else {
							if ( nlt ) {
								sx=x-1;
								selected=true;
							}else if ( nrt ) {
								sx=x+1;
								selected=true;
							}else if ( nup ) {
								sy=y-1;
								selected=true;
							}else if ( ndn ) {
								sy=y+1;
								selected=true;
							}
						}
					}
				}
			}
		}
		if ( !selected ) {
			do{
				sy = Math.floor(Math.random() * gridy);
				sx = Math.floor(Math.random() * gridx/2)*2+sy%2;
			}
			while( $scope.player[sy][sx][0]>100 );
		}
		if ($scope.player[sy][sx][0] < 100) {
			/* Computer Hits something ------------------------------------------*/
			setImage(sy,sx,103,false);
			var shipno = $scope.player[sy][sx][1];
			if ( --$scope.playersships[shipno][1] == 0 ) {
				sinkShip($scope.player,shipno,false);
				msgstore.hold({
					'title': ' -- Boom -- ',
					'text': "Я потопил "+$scope.params.shiptypes[$scope.playersships[shipno][0]][0]+"!",
					'type': 'alert-info'
				});
				
				if ( --$scope.playerlives == 0 ) {
					knowYourEnemy();
					msgstore.hold({
						'title': 'Я выйграл!',
						'text': "Жми обновить страницу и сразимся еще раз.",
						'type': 'alert-error'
					});
					$scope.params.playflag = false;
				}
			}
		} else {
			/* Computer Missed -----------------------------------*/
			setImage(sy,sx,102,false);
		}
	}

	function sinkShip(grid,shipno,isPC) {
		var y,x;
		for (y=0; y< gridx; ++y) {
			for (x=0; x<gridx; ++x) {
				if ( grid[y][x][1] == shipno )
					if (isPC){
						setImage(y,x, $scope.computer[y][x][2], true);
					}else{
						setImage(y,x, $scope.player[y][x][2], false);
					}
			}
		}
	}

	function knowYourEnemy() {
		var y,x;
		for (y=0; y<gridx; ++y) {
			for (x=0; x<gridx; ++x) {
				if ( $scope.computer[y][x][0] == 103 ){
					setImage(y,x, $scope.computer[y][x][2], true);
				} else if ( $scope.computer[y][x][0] < 100 ){
					setImage(y,x, $scope.computer[y][x][0], true);
				}
			}
		}
	}

	function setImage(y,x, id, isPC) {
		if ( isPC ) {					
			$scope.computer[y][x][0] = id;
		}else {
			$scope.player[y][x][0] = id;
			globalUserShips['items'][y][x][0] = id;
			globalUserShips['update'] = true;
			
		}
		
	}
			
	$scope.updateStatus = function() {
		$scope.params.status = [];
		for (i=0, l = $scope.computersships.length; i < l; ++i) {
			if ($scope.computersships[i][1] > 0) {
				$scope.params.status.push($scope.params.shiptypes[$scope.computersships[i][0]]);
			}
		}
	}

	$scope.setupPlayer = function(isPC){
		var y,x;
		grid = [];
		for (y=0;y<gridx;++y) {
			grid[y] = [];
			for (x=0;x < gridx;++x){
				grid[y][x] = [100,-1,0];
			}
		}

		var shipno = 0;
		var s;
		for (s = $scope.params.shiptypes.length-1; s>=0; --s) {
			var i;
			for (i=0; i < $scope.params.shiptypes[s][2]; ++i) {
				var d = Math.floor(Math.random()*2);
				var len = $scope.params.shiptypes[s][1], lx=gridx, ly=gridy, dx=0, dy=0;
				if ( d==0) {
					lx = gridx-len;
					dx=1;
				}else{
					ly = gridy-len;
					dy=1;
				}
				var x,y,ok;
				do {
					y = Math.floor(Math.random()*ly);
					x = Math.floor(Math.random()*lx);
					var j,cx=x,cy=y;
					ok = true;
					for (j=0;j<len;++j) {
						if (grid[cy][cx][0] < 100) {
							ok=false;
							break;
						}
						cx+=dx;
						cy+=dy;
					}
				}while(!ok);

				var j,cx=x,cy=y;
				for (j=0;j<len;++j) {
					grid[cy][cx][0] = ship[d][s][j];
					grid[cy][cx][1] = shipno;
					grid[cy][cx][2] = dead[d][s][j];
					cx+=dx;
					cy+=dy;
				}
				if (isPC) {
					$scope.computersships[shipno] = [s,$scope.params.shiptypes[s][1]];
					$scope.computerlives++;
				}else{
					$scope.playersships[shipno] = [s,$scope.params.shiptypes[s][1]];
					$scope.playerlives++;
				}
				shipno++;
			}
		}
		return grid;
	}
	
	/******* init **********/
	$scope.player = $scope.setupPlayer(false);
	$scope.computer = $scope.setupPlayer(true);
	$scope.updateStatus();
	globalUserShips['items'] = $scope.player;
	globalUserShips['update'] = true;
	init3d();
}]);
